MODEL.SETPERSISTENT.lua.wTollBoothWarning = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wTollBoothDistanceWarning = INT_MODEL(700)
MODEL.SETPERSISTENT.lua.wTollBoothTTSVoice = BOOL_MODEL(false)
MODEL.SETPERSISTENT.lua.wTollBoothTTSVoiceDistancePhrase = BOOL_MODEL(true)
MODEL.SET.lua.wTollBoothTrigger = BOOL_MODEL(true)
MODEL.SET.lua.wTollBoothIndex = INT_MODEL(0)
wTollBoothPopupID = -1
wTollBoothDelayedID = -1
wTollBoothOnDelayedID = -1
wTollBoothSpeakingID = 0
wTollBoothTestSpeakingID = 0
wUnitConvMeter2Unit = {float.new("1.093613298"), float.new("1.0"), float.new("3.280839895")}
sc_ConvertInputDistToCurrent_tollbooth = function(dist)
	return float.toInt(float.new(tostring(dist)) * wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
end
sc_inpValueInteger_onchange_tollbooth = function()
	local acceptable, InputKeys = getNextInput_Int(ui.inpValueInteger_tollbooth.VALUE(), sc_ConvertInputDistToCurrent_tollbooth(50), sc_ConvertInputDistToCurrent_tollbooth(5000))
	MODEL.lua.keyb_done = acceptable
	MODEL.lua.fuelinputkeys = InputKeys
	MODEL.regional.keyboard.smartkey_model("lua.fuelinputkeys")
end
sc_SelectValueInteger_tollbooth = function()
	sc_NextStateAnim(st_InputValueInteger_tollbooth, "horz_scroll", 1, "")
	txtTitle.TEXT = m_i18n("Set distance for warning")
	inpValueInteger_tollbooth.value = L""
	inpValueInteger_tollbooth.EMPTYTITLE = translated_format(m_i18n("<Enter Number (%s)>"), (towstring(sc_ConvertInputDistToCurrent_tollbooth(50)) .. L".." .. towstring(sc_ConvertInputDistToCurrent_tollbooth(5000))))
	sc_inpValueInteger_onchange_tollbooth()
	KEY("RETURN", sc_SelectValueIntegerDone_tollbooth)
	ui.vKeyTableDone = sc_SelectValueIntegerDone_tollbooth
end
createState("st_InputValueInteger_tollbooth")
st_InputValueInteger_tollbooth:useLayers(backgroundLayers, "ui_InputValueInteger_tollbooth")
st_InputValueInteger_tollbooth.init = function()
	MODEL.lua.easyShowDoneKey = true
	MODEL.regional.keyboard.load_panel_by_name(L"Core Numbers")
	MODEL.lua.InputValidatorIsDate = true
	wTmpdateDelimiter = MODEL.lua.dateDelimiter()
	MODEL.lua.dateDelimiter = 0
end
st_InputValueInteger_tollbooth.done = function()
	KEY("RETURN")
	MODEL.lua.InputValidatorIsDate = false
	MODEL.lua.dateDelimiter = wTmpdateDelimiter
	MODEL.regional.keyboard.on_close_panel()
	MODEL.regional.keyboard.smartkey_model("")
end
sc_SelectValueIntegerDone_tollbooth = function()
	local result = var.new()
	inpValueInteger_tollbooth:ISEMPTY(result)
	if not result() then
		MODEL.lua.wTollBoothDistanceWarning = float.toInt(float.new(tostring(ui.inpValueInteger_tollbooth.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end
sc_wReadOutTollBoothSupported = function()
	return MODEL.regional.current_voice.is_tts() and MODEL.regional.is_it_voice_localizable(m_i18n_voice("Toll booth,")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("After %s"))
end
sc_wGetTextReadOutTollBooth = function(dist)
	local distphrase = dist > 20 and MODEL.lua.wTollBoothTTSVoiceDistancePhrase() and (translated_voice_format(m_i18n_voice("After %s"), builtin.format(L"%{distance:3}", dist)) .. L": ") or L""
	return distphrase .. translate_voice("Toll booth,")
end
sc_wReadOutTollBooth = function()
	if not MODEL.navigation.is_in_simulation() and MODEL.lua.wTollBoothTTSVoice() then
		if sc_wReadOutTollBoothSupported() and not (wDASpeakingID or wSpeedCameraSpeakingID or wDASpeakingID_datts or MODEL.sound.os_muted() or MODEL.sound.voice_muted()) then
			local text = sc_wGetTextReadOutTollBooth(MODEL.route.list.navigated.itiner.list[MODEL.lua.wTollBoothIndex()].remaining_length())
			if wTollBoothSpeakingID then
				PromptCancel(wTollBoothSpeakingID)
				wTollBoothSpeakingID = 0
			end
			if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
				wTollBoothSpeakingID = MODEL.sound.speech.say("voice.ui", text, {priority = 21, boosted_priority = 25, callback = function(res) if res > 1 then wTollBoothSpeakingID = 0 end end})
			end
		else
			MODEL.sound.playchanneltest("alarmeffect", L"!msgbox")
		end
	end
end
sc_wTollBoothSetIndex = function()
	local witiner = MODEL.route.list.navigated.itiner.list
	local tollindex = 0
	for i = 0, witiner.size() - 1 do
		if witiner[i].remaining_length() > (MODEL.lua.wTollBoothDistanceWarning() + witiner[0].remaining_length()) then
			break
		end
		if witiner[i].type_small() == 40 then
			tollindex = i
			break
		end
	end
	MODEL.lua.wTollBoothIndex = tollindex
end
sc_wTollBoothStatusChanged = function()
	killDelayed(wTollBoothDelayedID)
	wTollBoothDelayedID = doDelayed(5, sc_wCheckTollBoothStatus)
end
sc_wCheckTollBoothStatus = function()
	if MODEL.route.list.navigated.has_navigable_path() and MODEL.route.list.navigated.itiner.list[MODEL.lua.wTollBoothIndex()].type_small() == 40 and MODEL.route.list.navigated.itiner.list[MODEL.lua.wTollBoothIndex()].remaining_length() <= MODEL.lua.wTollBoothDistanceWarning() and MODEL.gps.connection_status() < 3 and (MODEL.navigation.car_pos_valid() or MODEL.gps.valid() or MODEL.navigation.dead_reckoning()) then
		sc_wShowTollBoothPopup()
	else
		sc_wRemoveTollBoothPopup()
	end
end
sc_wShowTollBoothPopup = function()
	sc_RemoveMapPopupById(wTollBoothPopupID)
	local targetlayer = wPortrait and ui_wMapSidePanel_ptls_TollBooth or ui_wMapSidePanel_TollBooth
	MODEL.screen.msgbox.new.setup(1)
	MODEL.screen.msgbox.new.set_layer(targetlayer)
	MODEL.screen.msgbox.new.add_tag("popup")
	MODEL.screen.msgbox.new.set_title("tollbooth")
	wTollBoothPopupID = MODEL.screen.msgbox.create_new()
	if (st_EasyNav.isActive or vActiveState() == "st_screensaver") and MODEL.screen.msgbox.is_onscreen() and MODEL.screen.msgbox.on_screen.title() == "tollbooth" then
		sc_wReadOutTollBooth()
	end
end
sc_wRemoveTollBoothPopup = function()
	if wTollBoothSpeakingID then
		PromptCancel(wTollBoothSpeakingID)
		wTollBoothSpeakingID = 0
	end
	sc_RemoveMapPopupById(wTollBoothPopupID)
end
st_EasyNav:useLayers(ui_wTollBoothPropLayer,ui_wTollBoothPropLayer_uid)
sc_wTollBoothUpdateOn = function()
	killDelayed(wTollBoothOnDelayedID)
	wTollBoothOnDelayedID = doDelayed(1, function()
		MODEL.route.list.navigated.itiner.enable_update_list = true
		if not (MODEL.route.list.navigated.itiner.detailmode() == "normal" or MODEL.route.list.navigated.itiner.detailmode() == "verbose") then
			MODEL.route.list.navigated.itiner.detailmode = "normal"
		end
	end)
end
sc_wTollBoothTrigger = function()
	MODEL.lua.wTollBoothTrigger = false
	MODEL.lua.wTollBoothTrigger = true
end
sc_wTollBoothSettings_OnRelease_20 = function()
	sc_NextStateAnim(st_wTollBoothSettings, "horz_scroll", 1, "")
end
createState("st_wTollBoothSettings")
st_wTollBoothSettings:useLayers(backgroundLayers, "ui_wTollBoothSettings")
st_wTollBoothSettings.init = function()
	obs_wtollboothwarning:STOP()
	obs_wtollboothwarning_itiner:STOP()
	txtTitle.TEXT = m_i18n("Toll Booth Warning Settings")
end
st_wTollBoothSettings.done = function()
	if wTollBoothTestSpeakingID then
		PromptCancel(wTollBoothTestSpeakingID)
		wTollBoothTestSpeakingID = 0
	end
end
st_wTollBoothSettings.exit = function()
	if MODEL.lua.wTollBoothWarning() then
		obs_wtollboothwarning:START()
		obs_wtollboothwarning_itiner:START()
	else
		sc_wRemoveTollBoothPopup()
	end
end
sc_wTollBoothTTS_play = function()
	if wTollBoothTestSpeakingID then
		PromptCancel(wTollBoothTestSpeakingID)
		wTollBoothTestSpeakingID = 0
	end
	if not (MODEL.sound.speech.is_say_bool() and MODEL.sound.speech.saying_source() == "voice.guidance") then
		wTollBoothTestSpeakingID = MODEL.sound.speech.say("voice.ui", sc_wGetTextReadOutTollBooth(MODEL.lua.wTollBoothDistanceWarning()), {callback = function(res) if res > 1 then wTollBoothTestSpeakingID = 0 end end})
	end
end
if MODEL.lua.wTollBoothWarning() then
	obs_wtollboothwarning:START("NO_TRIGGER")
	obs_wtollboothwarning_itiner:START()
end
